"""
Rotar agentes de usuario:
    https://www.scrapehero.com/how-to-fake-and-rotate-user-agents-using-python-3/
    
Rotar proxies e ip:
    https://www.scrapehero.com/how-to-rotate-proxies-and-ip-addresses-using-python-3/

@author: Francisco Rodriguez Alfaro
@email: fran@datamanagement.es
@linkedin: https://www.linkedin.com/in/francrevillent/
"""
from datetime import datetime

class ExtractEmpresas():
    
    URL_INICIO = "https://guiaempresas.universia.es"
    userAgent = None
    
    filtro_provincias = ( "https://guiaempresas.universia.es/provincia/ALICANTE/" )
    
    filtro_localidades = ( "" 
                          , "https://guiaempresas.universia.es/localidad/CREVILLENT-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/ALICANTE-ALACANT/"
                          #, "https://guiaempresas.universia.es/localidad/ALCOY-ALCOI-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/TORREVIEJA-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/ELDA-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/VILLENA-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/SAN-VICENTE-RASPEIG-SANT-VICENT-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/ELCHE-ELX-ALICANTE/"
                          #, "https://guiaempresas.universia.es/localidad/CAMPELLO-ALICANTE/"
                          )
    
    conexion = None
    logTrazabilidad = None
    list_provincia = list()
    list_localidades = list()
    list_empresas = list()
    lista_localidades_paginas = list()
    list_info_empresas = list()
    
    
    def __init__( self, conexion, logTrazabilidad, userAgent ):
        
        self.conexion = conexion
        self.logTrazabilidad = logTrazabilidad
        self.userAgent = userAgent
        
        print("ExtractEmpresas Creado")
        
    def leerEmpresas(self):
        
        def importarEnlacesProvincias(self):
            self.list_provincia.clear()
            
            html = self.userAgent.RequestURL( self.URL_INICIO )
            #print(html)
            
            string_desde = """/provincia/"""
            string_hasta = ">"
            
            pos = 0
            while ( html.find( string_desde, pos ) != -1 ):
                
                if( html.find( string_desde, pos ) == pos ):
                    pos_ini = html.find( string_desde, pos )
                    pos_fin = html.find( string_hasta, pos_ini )
                    
                    subtexto = html[ pos_ini: pos_fin ]
                    url = self.URL_INICIO + subtexto.replace('"', "")
                    
                    if( "title" not in subtexto):
                        self.list_provincia.append( url )
                        
                pos += 1
        
        def importarLocalizacionesProvincias(self):
            
            self.list_localidades.clear()
            for provincia in self.list_provincia:
                
                # Checkear las provincias que queremos filtrar
                if(provincia in self.filtro_provincias ):
                    print( provincia )
                    
                    fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
                    self.logTrazabilidad.iniStatusActivity( URL = provincia
                                                              , DESCRIPCION = "importarLocalizacionesProvincias"
                                                              , FECHA = fecha_process
                                                              ,  STATUS = 0 )
                    
                    
                    html = self.userAgent.RequestURL( provincia )
                    
                    palabra_desde = """/localidad/"""
                    palabra_hasta = ">"
                    
                    pos = 0
                    while ( html.find( palabra_desde, pos ) != -1 ):
                        if( html.find( palabra_desde, pos ) == pos ):
                            pos_ini = html.find( palabra_desde, pos )
                            pos_fin = html.find( palabra_hasta, pos_ini )
                            
                            subtexto = html[ pos_ini: pos_fin ]
                            url = self.URL_INICIO + subtexto.replace('"', "")
                        
                            self.list_localidades.append(  url )
                            
                            importarEmpresasLocalizaciones(self, URL_LOCALIZACION = url )
                            
                        pos += 1
                        
                    fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
                    self.logTrazabilidad.updateStatusActivity( URL = provincia
                                          , DESCRIPCION = "importarLocalizacionesProvincias"
                                          , FECHA = fecha_process
                                          ,  STATUS = 1 )
        
        
        def importarEmpresasLocalizaciones( self, URL_LOCALIZACION ):
            
            def obtenerCantidadPaginas(html):
                
                palabra_desde = """/?qPagina"""
                palabra_hasta = """>"""
                
                pos = 0
                lista_paginas = list()
                while ( html.find( palabra_desde, pos ) != -1 ):
                    if( html.find( palabra_desde, pos ) == pos ):
                        pos_ini = html.find( palabra_desde, pos )
                        pos_fin = html.find( palabra_hasta, pos_ini )
                        
                        subtexto = html[ pos_ini: pos_fin ].replace("/?qPagina=", "").replace('"', "")
                        lista_paginas.append( subtexto )
                    pos += 1
                    
                max = 0
                for num in lista_paginas:
                    num = int(num)
                    if(num >= max):
                        max = num
                    
                return max
                
            def obtenerEnlacesLocalidadesTodasPaginas(localidad, cant_paginas):
                
                lista_localidades_paginas = list()
                for i in range(1, cant_paginas+1):
                    
                    url = localidad + "?qPagina=" + str(i)
                    lista_localidades_paginas.append(url)
                    
                return lista_localidades_paginas
                
                
            # Si la URL está dentro de la lista de localidades entonces obtener
            if(URL_LOCALIZACION in self.filtro_localidades):
            
                html = self.userAgent.RequestURL( URL_LOCALIZACION )
                
                cant_paginas = obtenerCantidadPaginas( html )
                self.lista_localidades_paginas = obtenerEnlacesLocalidadesTodasPaginas( URL_LOCALIZACION, cant_paginas )
                   
                # Ahora recorrer para cada localización todas las páginas para extraer todas las empresas
                for pagina in self.lista_localidades_paginas:
                    
                    fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
                    self.logTrazabilidad.iniStatusActivity( URL = pagina
                                          , DESCRIPCION = "importarEmpresasLocalizaciones"
                                          , FECHA = fecha_process
                                          ,  STATUS = 0 )
                    
                    
                    html_2 = self.userAgent.RequestURL( pagina )
                    
                    palabra_desde = """<a href="/"""
                    palabra_hasta = ">"
                    
                    pos = 0
                    while ( html_2.find( palabra_desde, pos ) != -1 ):
                        if( html_2.find( palabra_desde, pos ) == pos ):
                            pos_ini = html_2.find( palabra_desde, pos )
                            pos_fin = html_2.find( palabra_hasta, pos_ini )
                            
                            subtexto = html_2[ pos_ini: pos_fin ]
                            url = self.URL_INICIO + "/" + subtexto.replace('"', "").replace("<a href=/", "")
                            
                            if(".html" in url):
                                self.list_empresas.append( url )
                                
                                importarInfoEmpresas(self, url )
                        
                        pos += 1
                        
                    fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
                    self.logTrazabilidad.updateStatusActivity( URL = pagina
                                          , DESCRIPCION = "importarEmpresasLocalizaciones"
                                          , FECHA = fecha_process
                                          ,  STATUS = 1 )
                    

        def importarInfoEmpresas(self, URL_EMPRESA ):
            
            def obtenerValor(html, palabra_desde, palabra_hasta):
                valor = ""
                pos = 0
                while ( html.find( palabra_desde, pos ) != -1 ):
                    if( html.find( palabra_desde, pos ) == pos ):
                        pos_ini = html.find( palabra_desde, pos )
                        pos_fin = html.find( palabra_hasta, pos_ini )
                        
                        subtexto = html[ pos_ini: pos_fin ]
                        valor = subtexto.replace(palabra_desde, "")
                        
                    pos += 1
                
                return valor
            
            nombre = ""
            direccion = ""
            localidad = ""
            provincia = ""
            telefono = ""
            empleados = ""
            fecha_creacion = ""
            CNAE = ""
            latitud = ""
            longitud = ""
            facturacion = ""
            
            fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
            self.logTrazabilidad.iniStatusActivity( URL = URL_EMPRESA
                                  , DESCRIPCION = "importarInfoEmpresas"
                                  , FECHA = fecha_process
                                  ,  STATUS = 0 )
            
            
            print(URL_EMPRESA)
            html = self.userAgent.RequestURL( URL_EMPRESA )
            
            
            if(html.find("Demasiadas peticiones detectadas") != 0  ):
                print("REFRESCA LA PÁGINA PORQUE HA SALTADO EL CAPTCHA")
            
            ### Obtener el nombre de la empresa
            palabra_desde = """<h1 class="h1ficha fn localbusiness" itemprop="name">"""
            palabra_hasta = "</h1>"
            nombre = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener la dirección
            palabra_desde = """<span class="street-address" id="situation_calle" itemprop="Address">"""
            palabra_hasta = "</span>"
            direccion = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener la localidad
            palabra_desde = """<span class="locality" id="situation_loc">"""
            palabra_hasta = "</span>"
            localidad = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener la provincia
            palabra_desde = """<span id="situation_prov">"""
            palabra_hasta = "</span>"
            provincia = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener el telefono
            palabra_desde = """<td class="td_ficha_univ" colspan="2" itemprop="telephone">"""
            palabra_hasta = "</td>"
            telefono = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener empleados
            palabra_desde = """<strong>&Uacute;ltimo n&uacute;mero de empleados registrado: </strong>"""
            palabra_hasta = "</p>"
            empleados = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener fecha de creacion
            palabra_desde = """Fecha de creaci&oacute;n:</p></th><td class="td_ficha_univ" colspan="2">"""
            palabra_hasta = "</td>"
            fecha_creacion = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener fecha de creacion
            palabra_desde = """CNAE: </p></th><td class="td_ficha_univ" colspan="2">"""
            palabra_hasta = "</td>"
            CNAE = obtenerValor(html, palabra_desde, palabra_hasta)
            
            ### Obtener coordenadas
            palabra_desde = 'paramBusqueda="'
            palabra_hasta = """";"""
            coordenadas = obtenerValor(html, palabra_desde, palabra_hasta)
            
            latitud = coordenadas.split(",")[0]
            if( len(coordenadas.split(",")) > 1 ):
                longitud = coordenadas.split(",")[1]
            
            ### Obtener coordenadas
            palabra_desde = """Facturaci&oacute;n registrada: </strong>"""
            palabra_hasta = """</p>"""
            facturacion = obtenerValor(html, palabra_desde, palabra_hasta)
            
            
            objeto = { "nombre": nombre
                        , "direccion": direccion
                        , "localidad": localidad 
                        , "provincia": provincia
                        , "telefono": telefono
                        , "empleados": empleados
                        , "fecha_creacion": fecha_creacion
                        , "cnae": CNAE
                        , "coordenadas": coordenadas
                        , "latitud": latitud
                        , "longitud": longitud
                        , "facturacion": facturacion
                        }
            self.list_info_empresas.append( objeto )
            
            
            sql_insert = """ insert into ds_empresas_scraping ( url, nombre, direccion, localidad, provincia
                                								, telefono, empleados, fecha_creacion, cnae
                                								, coordenadas, latitud, longitud, facturacion
                                                                , fecha_insert, html_response )
                            values ( %s, %s, %s, %s, %s, %s, %s 
                            		, %s, %s, %s, %s, %s, %s, now(), %s ) """
                            
            params = ( URL_EMPRESA, nombre[0:99], direccion, localidad, provincia, telefono, empleados, fecha_creacion
                      , CNAE, coordenadas, latitud, longitud, facturacion, html[0: 6000]  )
            
            
            self.conexion.execQuery( Query_params = sql_insert, params = params )
            self.conexion.commit()
            
            
            fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
            self.logTrazabilidad.updateStatusActivity( URL = URL_EMPRESA
                                  , DESCRIPCION = "importarInfoEmpresas"
                                  , FECHA = fecha_process
                                  ,  STATUS = 1 )
            
        importarEnlacesProvincias(self)
        importarLocalizacionesProvincias(self)
                
        
    

        
"""
create table ds_empresas_scraping (
	url varchar(1000)
	, nombre varchar(100)
	, direccion varchar(1000)
	, localidad varchar(500)
	, provincia varchar(100)
	, telefono varchar(100)
	, empleados varchar(100)
	, fecha_creacion varchar(100)
	, cnae varchar(5000)
	, coordenadas varchar(100)
	, latitud varchar(50)
	, longitud varchar (50)
	, facturacion varchar(100)
	, fecha_insert datetime
	, html_response varchar(6000)
)
"""





