# -*- coding: utf-8 -*-
"""
Created on Mon Oct  7 15:19:15 2019

@author: Francisco Rodriguez Alfaro
@email: fran@datamanagement.es
@linkedin: https://www.linkedin.com/in/francrevillent/
"""
from datetime import datetime

class LogTrazabilidad():
    
    IDPROCESS = 0
    conexion = None
    ETL_MAESTRO = None
    conexion = None
    
    def __init__(self, conexion, ETL_MAESTRO):
        self.IDPROCESS = self.getIdProcess()
        self.conexion = conexion
        self.ETL_MAESTRO = ETL_MAESTRO
        print("Log Trazabilidad: " + self.IDPROCESS)
        
    def getIdProcess(self):
        return datetime.now().strftime("%Y%m%d%H%M%S")
        
    def iniStatusActivity( self, URL, DESCRIPCION, FECHA, STATUS, CANT_REGISTROS = None ):
        """ Insertar un nuevo registro en la tabla de control """
        
        sql_insert = """insert into ctl_activity_process ( id_process, etl_master, descri_activity, url, status, start_date, cant_row ) VALUES """
        sql_insert += """ ( %s, %s, %s, %s, %s, %s, %s ) """
        params = ( self.IDPROCESS, self.ETL_MAESTRO, DESCRIPCION, URL, STATUS, FECHA, CANT_REGISTROS )
        self.conexion.execQuery( sql_insert, params )
        self.conexion.commit()
    
    def updateStatusActivity( self, URL, DESCRIPCION, FECHA, STATUS ):
        """ Modificar el estado y la fecha de finalización del registro insertado """
        
        sql_update = """ update ctl_activity_process set 
                            	status = %s
                                , end_date = %s
                        where id_process = %s
                        	and descri_activity = %s
                        	and url = %s
                        	and start_date = %s
                    """
        params = ( STATUS, datetime.now(), self.IDPROCESS, DESCRIPCION, URL, FECHA )
        self.conexion.execQuery( sql_update, params )
        self.conexion.commit()
        
    def getIdprocess(self):
        return self.IDPROCESS
    
    
    
    
    
    


"""
CREATE TABLE ctl_activity_process (
  etl_master varchar(50),
  id_process bigint(20),
  url varchar(1000),
  descri_activity varchar(100),
  status int(11),
  start_date datetime,
  end_date datetime,
  cant_row int(11),
  fecha_desde date,
  fecha_hasta date
);
        
"""









    