# -*- coding: utf-8 -*-
"""
Created on Fri Oct 18 17:17:14 2019
@author: Francisco Rodriguez Alfaro
@email: fran@datamanagement.es
@linkedin: https://www.linkedin.com/in/francrevillent/
"""
from CLASES.LogTrazabilidad import LogTrazabilidad
from CLASES.ExtractEmpresas import ExtractEmpresas
from CLASES.Connection import Connection
from CLASES.UserAgentRandom import UserAgentRandom
from datetime import datetime
import json


# Obtener las variables de acceso
with open('./config.json', 'r') as file:
    config = json.load(file)


conexion = Connection( USER = config['USER']
                        , PASS = config['PASS']
                        , HOST = config['HOST']
                        , DATABASE = config['DATABASE'] )


#Crear la trazabilidad para ir registrando en la tabla de control todo lo que va sucediendo
logTrazabilidad = LogTrazabilidad( conexion = conexion
                                  , ETL_MAESTRO = "Extracción de Empresas")

fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
logTrazabilidad.iniStatusActivity( URL = "N/A"
                                  , DESCRIPCION = "PROCESO"
                                  , FECHA = fecha_process
                                  ,  STATUS = 0 )


# Para que no bloqueen el cliente web, hay que pasar un user-agent diferente en cada petición
userAgent = UserAgentRandom()

#Extraer empresas e insertar a la BBDD directamente
extracEmpresas = ExtractEmpresas( conexion, logTrazabilidad, userAgent )
extracEmpresas.leerEmpresas()


fecha_process = datetime.now().strftime("%Y-%m-%d %H:%M:%S") # Esta fecha es un campo clave para la trazabilidad
logTrazabilidad.updateStatusActivity( URL = "N/A"
                                  , DESCRIPCION = "PROCESO"
                                  , FECHA = fecha_process
                                  ,  STATUS = 1 )






































